/***
 * Excerpted from "Stripes: and Java Web Development is Fun Again",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/fdstr for more book information.
***/
package stripesbook.action;

import java.util.Collection;
import net.sourceforge.stripes.action.DefaultHandler;
import net.sourceforge.stripes.action.ForwardResolution;
import net.sourceforge.stripes.action.Resolution;
import stripesbook.model.Contact;


public class ContactListActionBean extends ContactBaseActionBean {

    private static final String LIST="/WEB-INF/jsp/contact_list.jsp";
    private static final String VIEW="/WEB-INF/jsp/contact_view.jsp";
    private static final String TABLE="/WEB-INF/jsp/parts/contact_table.jsp";

    private static final String DETAILS =
        "/WEB-INF/jsp/parts/contact_details.jsp";



    @DefaultHandler
    public Resolution list() {
        return new ForwardResolution(LIST);
    }
    public Resolution table() {
        return new ForwardResolution(TABLE);
    }
    public Resolution view() {
        return new ForwardResolution(VIEW);
    }

    public Resolution details() {
        return new ForwardResolution(DETAILS);
    }

    public Resolution delete() {
        Contact deleted = getContact();
        contactDao.delete(deleted);
        contactDao.commit();
        return new ForwardResolution(TABLE);
    }
    private Collection<Contact> contacts;
    public Collection<Contact> getContacts() {
        if (contacts == null) {
            contacts = getUser().getContacts();
        }
        return contacts;
    }

    
    public String filter;

    public Resolution findByName() {
        if (filter != null && filter.length() > 0) {
            contacts = contactDao.findByName(filter, getUser());
        }
        return new ForwardResolution(TABLE);
    }
    

}

